diff --git a/Makefile b/Makefile
index 6415270..2b7f003 100644
--- a/Makefile
+++ b/Makefile
@@ -6,8 +6,10 @@ release: dist/tfh_dist.zip
 
 dist/packsquash:
 	sh scripts/getsquash
-dist/tfh.base.zip:
-	deno task build
+assets/decals/**/*:
+	bun run decals
+dist/tfh.base.zip: assets/decals/**/*
+	bun run build
 dist/tfh_dist.zip: dist/packsquash dist/tfh.base.zip
 	dist/packsquash packsquash.toml
 on/finish:
diff --git a/decals.ts b/decals.ts
index 5c12378..a536824 100644
--- a/decals.ts
+++ b/decals.ts
@@ -1,115 +1,125 @@
 import { createHash } from "node:crypto";
-import * as path from "https://deno.land/std/path/mod.ts";
+import { copyFile, mkdirSync, statSync } from "node:fs";
+import * as path from "node:path";
 
 ["dist", "assets/decals/models", "assets/decals/textures/item"].map((d) =>
-  Deno.mkdirSync(d, { recursive: true })
+	mkdirSync(d, { recursive: true }),
 );
 
 const vd = (a: any) => (console.log(a), a),
-  lfs = (...a: any[]) => (...b: any[]) => a[0] && console.log(...a, ...b);
+	lfs =
+		(...a: any[]) =>
+		(...b: any[]) =>
+			a[0] && console.log(...a, ...b);
 
 const textures: Record<string, string> = {},
-  models: Record<string, string> = {},
-  explorable: string[] = [
-    `<h1>Team Fuho's decal explorer</h1>
+	models: Record<string, string> = {},
+	explorable: string[] = [
+		`<h1>Team Fuho's decal explorer</h1>
 Invisible item_frame: <span class=ip>minecraft:give @p item_frame{EntityTag:{Invisible:1}}</span>
 <link rel="stylesheet" type="text/css" href="explore.css" />
 <div class=expl_gr>`.replace("\n", "<br>"),
-  ];
+	];
 
-const df = Deno.readTextFileSync("decals/decals.txt")
-  .split("\n")
-  .map((i) => i.trim())
-  .filter((i) => i)
-  .filter((i) => !i.trimStart().startsWith("#"));
+const df = (await Bun.file("decals/decals.txt").text())
+	.split("\n")
+	.map((i) => i.trim())
+	.filter((i) => i)
+	.filter((i) => !i.trimStart().startsWith("#"));
 
 function sign(n: string): string {
-  const { mtime, size } = Deno.statSync(n);
-  return `${mtime} ${size}`;
+	const { mtime, size } = statSync(n);
+	return `${mtime} ${size}`;
 }
 
 const hash = (t: string): string =>
-  createHash("sha1").update(t).digest("base64url").slice(0, 12);
+	createHash("sha1").update(t).digest("base64url").slice(0, 12);
 
-const ha = (t: boolean) => (n: string, s?: any): string =>
-  (t ? textures : models)[n] ||
-  ((t ? textures : models)[n] = hash(
-    `${n} ${t ? sign(n) : [n, s || []].flat().join()}`,
-  )) ||
-  (t ? textures : models)[n];
+const ha =
+	(t: boolean) =>
+	(n: string, s?: any): string =>
+		(t ? textures : models)[n] ||
+		((t ? textures : models)[n] = hash(
+			`${n} ${t ? sign(n) : [n, s || []].flat().join()}`,
+		)) ||
+		(t ? textures : models)[n];
 
 const mode = {
-  fast: "f",
-  default: "d",
+	fast: "f",
+	default: "d",
 };
 
 const tex = ha(true),
-  mod = ha(false);
+	mod = ha(false);
 
 function add(i: string, n: string, m: string, x: string, y: string, s: string) {
-  i = Number.parseInt(i);
-  m = mode[m as keyof typeof mode] || mode.fast;
-  x = Number.parseFloat(x);
-  y = Number.parseFloat(y);
-  s = Number.parseFloat(s);
-  const mn = `m${i}_${mod(n, [n, m, x, y, s])}`,
-    mp = vd(path.join("assets/decals/models/", `${mn}.json`)),
-    dt = tex(path.join("decals/", `${n}.png`));
-  explorable.push(
-    `<div class=expl_i>
+	i = Number.parseInt(i);
+	m = mode[m as keyof typeof mode] || mode.fast;
+	x = Number.parseFloat(x);
+	y = Number.parseFloat(y);
+	s = Number.parseFloat(s);
+	const mn = `m${i}_${mod(n, [n, m, x, y, s])}`,
+		mp = vd(path.join("assets/decals/models/", `${mn}.json`)),
+		dt = tex(path.join("decals/", `${n}.png`));
+	explorable.push(
+		`<div class=expl_i>
 <b><code>${i} ${n}</code> ${m}</b> <span class=ip>minecraft:give @p paper{CustomModelData:${i}\}</span>
-<div class=expl_bg><img src=assets/decals/textures/t${dt}.png class=${m} style=--x:${-x};--y:${-y};--s:${s}></div>
+<div class=expl_bg><img src=assets/decals/textures/item/t${dt}.png class=${m} style=--x:${-x};--y:${-y};--s:${s}></div>
 </div>`,
-  );
-  function gentf(slt: string) {
-    return {
-      translation: [x * 32, y * 32, -0.03],
-      scale: Array(3).fill(
-        s * (m === mode.default ? 2 : 1) * (slt === "head" ? 1 : 1),
-      ),
-      rotation: m === "d" ? [0, 180, 0] : undefined,
-    };
-  }
-  Deno.writeTextFileSync(
-    mp,
-    JSON.stringify({
-      parent: `fuho:${m}`,
-      textures: {
-        [m === mode.default ? "layer0" : "0"]: `decals:item/t${dt}`,
-      },
-      display: {
-        head: gentf("head"),
-        fixed: gentf("frame"),
-      },
-    }),
-  );
-  lfs()();
+	);
+	function gentf(slt: string) {
+		return {
+			translation: [x * 32, y * 32, -0.03],
+			scale: Array(3).fill(
+				s * (m === mode.default ? 2 : 1) * (slt === "head" ? 1 : 1),
+			),
+			rotation: m === "d" ? [0, 180, 0] : undefined,
+		};
+	}
+	Bun.write(
+		mp,
+		JSON.stringify({
+			parent: `fuho:${m}`,
+			textures: {
+				[m === mode.default ? "layer0" : "0"]: `decals:item/t${dt}`,
+			},
+			display: {
+				head: gentf("head"),
+				fixed: gentf("frame"),
+			},
+		}),
+	);
+	lfs()();
 
-  return {
-    predicate: {
-      custom_model_data: i,
-    },
-    model: `decals:${mn}`,
-  };
+	return {
+		predicate: {
+			custom_model_data: i,
+		},
+		model: `decals:${mn}`,
+	};
 }
 
 const pp = vd(path.join("assets/minecraft/models/item/paper.json"));
-Deno.writeTextFileSync(
-  pp,
-  JSON.stringify({
-    parent: "minecraft:item/generated",
-    textures: {
-      layer0: "minecraft:item/paper",
-    },
-    overrides: df.map((s) => s.split(" ")).map((i) => add(...i)),
-  }),
+Bun.write(
+	pp,
+	JSON.stringify({
+		parent: "minecraft:item/generated",
+		textures: {
+			layer0: "minecraft:item/paper",
+		},
+		overrides: df.map((s) => s.split(" ")).map((i) => add(...i)),
+	}),
 );
 lfs()();
-Deno.writeTextFileSync("explore.html", [...explorable, "</div>"].join("\n"));
+Bun.write("explore.html", [...explorable, "</div>"].join("\n"));
+function buncp(left, right) {
+	Bun.write(right, Bun.file(left));
+}
 for (const [k, dn] of Object.entries(textures)) {
-  Deno.copyFileSync(
-    k,
-    vd(path.join("assets/decals/textures/", `item/t${dn}.png`)),
-  );
-  lfs(`* ${k}`)();
+	copyFile(
+		k,
+		vd(path.join("assets/decals/textures/", `item/t${dn}.png`)),
+		() => {},
+	);
+	lfs(`* ${k}`)();
 }
diff --git a/gulpfile.js b/gulpfile.js
index e13bf2c..a3a0988 100644
--- a/gulpfile.js
+++ b/gulpfile.js
@@ -3,165 +3,165 @@
  * @author stdpi
  */
 
-import { src, dest } from "gulp";
-import { task } from "gulp";
+import { Buffer } from "node:buffer";
+import { readFileSync, readdirSync, writeFile } from "node:fs";
+import { relative } from "node:path";
+import { Readable as ReadableStream } from "node:stream";
 import { series } from "async";
-import { default as zip } from "gulp-zip";
 import { deleteAsync } from "del";
-import { relative } from "node:path";
+import { dest, src } from "gulp";
+import { task } from "gulp";
+import { default as zip } from "gulp-zip";
 import sharp from "sharp";
-import { readFileSync, readdirSync, writeFile } from "node:fs";
-import { Readable as ReadableStream } from "node:stream";
-import { Buffer } from "node:buffer";
 
 const pdot = (s) => `.${s}`;
 
 const typeignore = ["bbmodel", "gitignore"].map(pdot),
-  typejson = ["json", "mcmeta"].map(pdot),
-  typeimage = ["png"].map(pdot);
+	typejson = ["json", "mcmeta"].map(pdot),
+	typeimage = ["png"].map(pdot);
 
 const ignoreGlob = typeignore.map((s) => `!./assets/**/*${s}`);
 
 const minJSON = (json) => Buffer.from(JSON.stringify(JSON.parse(json))),
-  optimizePNG = (img) =>
-    new ReadableStream({
-      read() {
-        sharp(img)
-          .png({
-            compressionLevel: 8,
-            progressive: true,
-          })
-          .toBuffer()
-          .then((data) => {
-            this.push(data);
-            this.push(null);
-          })
-          .catch((error) => {
-            // console.error(`Error processing image: ${error.message}`);
-            this.push(img);
-            this.push(null);
-          });
-      },
-    }),
-  opt = (file) => {
-    if (typejson.includes(file.extname)) {
-      file.contents = minJSON(file.contents);
-    } else if (typeimage.includes(file.extname)) {
-      file.contents = optimizePNG(file.contents);
-    }
-  },
-  dist = (list, dist, base, patch) =>
-    src([...list, ...ignoreGlob], {
-      base,
-    })
-      .on("data", opt)
-      .on("data", (file) => {
-        console.log(
-          "\x1b[32m+\x1b[0m",
-          relative(import.meta.dirname, file.path),
-        );
-      })
-      .pipe(dest(`./dist/${patch || "base"}/${dist}`)),
-  zipack = (outname, patch) =>
-    src([`dist/${patch || "base"}/**/*`])
-      .pipe(zip(outname))
-      .pipe(dest(".")),
-  patch = (cb, list, outname, patch) =>
-    series(
-      [
-        (cb) =>
-          dist(["./pack.mcmeta", "./pack.png", "LICENSE"], "./").on("end", cb),
-        (cb) =>
-          series(
-            //
-            list.map((l) => (cb) => dist(...l, patch).on("end", cb)),
-            cb,
-          ),
-        (cb) => zipack(`./dist/${outname}`, patch).on("end", cb),
-        (cb) =>
-          !process.env.noclean
-            ? deleteAsync(["./dist/pack/**/*"]).then(() => cb())
-            : cb(),
-      ],
-      cb,
-    );
+	optimizePNG = (img) =>
+		new ReadableStream({
+			read() {
+				sharp(img)
+					.png({
+						compressionLevel: 8,
+						progressive: true,
+					})
+					.toBuffer()
+					.then((data) => {
+						this.push(data);
+						this.push(null);
+					})
+					.catch((error) => {
+						// console.error(`Error processing image: ${error.message}`);
+						this.push(img);
+						this.push(null);
+					});
+			},
+		}),
+	opt = (file) => {
+		if (typejson.includes(file.extname)) {
+			file.contents = minJSON(file.contents);
+		} else if (typeimage.includes(file.extname)) {
+			file.contents = optimizePNG(file.contents);
+		}
+	},
+	dist = (list, dist, base, patch) =>
+		src([...list, ...ignoreGlob], {
+			base,
+		})
+			.on("data", opt)
+			.on("data", (file) => {
+				console.log(
+					"\x1b[32m+\x1b[0m",
+					relative(import.meta.dirname, file.path),
+				);
+			})
+			.pipe(dest(`./dist/${patch || "base"}/${dist}`)),
+	zipack = (outname, patch) =>
+		src([`dist/${patch || "base"}/**/*`])
+			.pipe(zip(outname))
+			.pipe(dest(".")),
+	patch = (cb, list, outname, patch) =>
+		series(
+			[
+				(cb) =>
+					dist(["./pack.mcmeta", "./pack.png", "LICENSE"], "./").on("end", cb),
+				(cb) =>
+					series(
+						//
+						list.map((l) => (cb) => dist(...l, patch).on("end", cb)),
+						cb,
+					),
+				(cb) => zipack(`./dist/${outname}`, patch).on("end", cb),
+				(cb) =>
+					!process.env.noclean
+						? deleteAsync(["./dist/pack/**/*"]).then(() => cb())
+						: cb(),
+			],
+			cb,
+		);
 
 const disabled_patches = readFileSync("./patches/.disabled.txt", {
-  encoding: "utf8",
+	encoding: "utf8",
 }).split("\n");
 const patches = readdirSync("./patches").filter(
-  (i) => !i.startsWith(".") && !disabled_patches.includes(i),
+	(i) => !i.startsWith(".") && !disabled_patches.includes(i),
 );
 task("default", (end) =>
-  patch(
-    end,
-    [
-      [["./assets/**/*"], "./", "./"],
-      ...patches.map((pn) => [
-        [`./patches/${pn}/**/*`],
-        "./",
-        `./patches/${pn}`,
-      ]),
-    ],
-    "tfh.fullpatch.zip",
-  ),
+	patch(
+		end,
+		[
+			[["./assets/**/*"], "./", "./"],
+			...patches.map((pn) => [
+				[`./patches/${pn}/**/*`],
+				"./",
+				`./patches/${pn}`,
+			]),
+		],
+		"tfh.fullpatch.zip",
+	),
 );
 
 task("patch", (end) => {
-  series(
-    [
-      // Base patch
-      (end) => patch(end, [[["./assets/**/*"], "./", "./"]], "tfh.base.zip"),
-      ...patches.map(
-        (pn) => (end) =>
-          patch(
-            end,
-            [[[`./patches/${pn}/**/*`], "./", `./patches/${pn}`]],
-            `tfh.${pn}.zip`,
-            pn.split(".")[0],
-          ),
-      ),
-    ],
-    end,
-  );
+	series(
+		[
+			// Base patch
+			(end) => patch(end, [[["./assets/**/*"], "./", "./"]], "tfh.base.zip"),
+			...patches.map(
+				(pn) => (end) =>
+					patch(
+						end,
+						[[[`./patches/${pn}/**/*`], "./", `./patches/${pn}`]],
+						`tfh.${pn}.zip`,
+						pn.split(".")[0],
+					),
+			),
+		],
+		end,
+	);
 });
 
 task("pdev", (end) =>
-  series(
-    [
-      ...patches.map(
-        (pn) => (cb) =>
-          series(
-            [
-              (cb) =>
-                src([`./patches/${pn}/**/*`, ...ignoreGlob], {
-                  base: `./patches/${pn}`,
-                })
-                  .pipe(dest(`../DEV--${pn}`))
-                  .on("end", cb),
-              (cb) =>
-                writeFile(
-                  `../DEV--${pn}/pack.mcmeta`,
-                  JSON.stringify({
-                    pack: {
-                      pack_format: 6,
-                      description: [
-                        "",
-                        {
-                          text: "AUTO GENERATED. DO NOT EDIT",
-                          bold: true,
-                          color: "red",
-                        },
-                      ],
-                    },
-                  }),
-                  cb,
-                ),
-            ],
-            cb,
-          ),
-      ),
-    ],
-    end,
-  ),
+	series(
+		[
+			...patches.map(
+				(pn) => (cb) =>
+					series(
+						[
+							(cb) =>
+								src([`./patches/${pn}/**/*`, ...ignoreGlob], {
+									base: `./patches/${pn}`,
+								})
+									.pipe(dest(`../DEV--${pn}`))
+									.on("end", cb),
+							(cb) =>
+								writeFile(
+									`../DEV--${pn}/pack.mcmeta`,
+									JSON.stringify({
+										pack: {
+											pack_format: 6,
+											description: [
+												"",
+												{
+													text: "AUTO GENERATED. DO NOT EDIT",
+													bold: true,
+													color: "red",
+												},
+											],
+										},
+									}),
+									cb,
+								),
+						],
+						cb,
+					),
+			),
+		],
+		end,
+	),
 );
diff --git a/scripts/mmeta.ts b/scripts/mmeta.ts
index 475015e..324ba2a 100644
--- a/scripts/mmeta.ts
+++ b/scripts/mmeta.ts
@@ -1,50 +1,51 @@
-import { crypto } from "https://deno.land/std/crypto/mod.ts";
-import { resolve, normalize } from "https://deno.land/std/path/mod.ts";
+import fs from "node:fs/promises";
+import path from "node:path";
 
-const distPath = normalize(resolve(Deno.cwd(), "dist"));
+const distPath = path.resolve(process.cwd(), "dist");
+
+async function getZipFiles() {
+	const zipFiles: string[] = [];
+	const files = await fs.readdir(distPath);
+
+	for (const file of files) {
+		const filePath = path.join(distPath, file);
+		const stat = await fs.stat(filePath);
+		if (stat.isFile() && file.endsWith(".zip")) {
+			zipFiles.push(filePath);
+		}
+	}
+
+	return zipFiles;
+}
+
+async function computeHash(filePath: string): Promise<string> {
+	const hasher = new Bun.CryptoHasher("sha1");
+	const fileBuffer = await fs.readFile(filePath);
+	hasher.update(fileBuffer);
+	return hasher.digest("hex");
+}
 
 async function processZipFiles() {
-  const zipFiles = [];
-
-  try {
-    for await (const entry of Deno.readDir(distPath)) {
-      if (entry.isFile && entry.name.endsWith(".zip")) {
-        zipFiles.push(resolve(distPath, entry.name));
-      }
-    }
-  } catch (error) {
-    console.error(`Error reading directory: ${error.message}`);
-    console.error(`Attempted to read directory: ${distPath}`);
-    return;
-  }
-
-  const fileMetadata = [];
-
-  for (const zipFile of zipFiles) {
-    try {
-      const fileContent = await Deno.readFile(zipFile);
-      const hash = await crypto.subtle.digest("SHA-1", fileContent);
-      const hashHex = Array.from(new Uint8Array(hash))
-        .map((b) => b.toString(16).padStart(2, "0"))
-        .join("");
-
-      const fileName = zipFile.split(/[/\\]/).pop();
-      const url = `https://whitespace.teamfuho.net/Team-Fuho/resourcepacks/dist/${fileName}`;
-
-      fileMetadata.push({ url, hash: hashHex });
-    } catch (error) {
-      console.error(`Error processing file ${zipFile}: ${error.message}`);
-    }
-  }
-
-  try {
-    await Deno.writeTextFile(
-      `${distPath}/metadata.json`,
-      JSON.stringify(fileMetadata, null, 2),
-    );
-  } catch (error) {
-    console.error(`Error writing metadata file: ${error.message}`);
-  }
+	const zipFiles = await getZipFiles();
+	const fileMetadata: { url: string; hash: string }[] = [];
+
+	for (const zipFile of zipFiles) {
+		try {
+			const hash = await computeHash(zipFile);
+			const fileName = path.basename(zipFile);
+			const url = `https://whitespace.teamfuho.net/Team-Fuho/resourcepacks/dist/${fileName}`;
+			fileMetadata.push({ url, hash });
+		} catch (error) {
+			console.error(`Error processing file ${zipFile}: ${error.message}`);
+		}
+	}
+
+	try {
+		const metadataPath = path.join(distPath, "metadata.json");
+		await fs.writeFile(metadataPath, JSON.stringify(fileMetadata, null, 2));
+	} catch (error) {
+		console.error(`Error writing metadata file: ${error.message}`);
+	}
 }
 
 processZipFiles();
